#import <Foundation/Foundation.h>
#import <CoreBluetooth/CoreBluetooth.h>
#import "AsReaderBLEProtocols.h"

@interface AsReaderBleMgr : NSObject
@property (nonatomic, weak) id<AsReaderBLEProtocols> delegate;

+ (instancetype) sharedInstance;
//-(NSArray *) getPreripheralList;

/**
 *  @brief      [ONLY SDK USE] Response of all
 *  @details    TThis function starts a device search.
 */
- (BOOL) scanBLE;

/**
 *  @brief      [ONLY SDK USE] Response of all
 *  @details    This function will stop searching for devices.
 */
- (void) stopSacnBLE;

/**
 *  @brief      [ONLY SDK USE] Response of all
 *  @details    This function checks the connection status.
 *  @return     YES : Connected  NO: Disconnected
 */
- (BOOL) isOpened;

/**
 *  @brief      [ONLY SDK USE] Response of all
 *  @details    Disconnect the device.
 */
- (void) close;

/**
 *  @brief      [ONLY SDK USE] Response of all
 *  @details    This function transfers data.
 *  @return     YES : Success  NO: Fail
 */
- (BOOL) send:(NSData*)data;

/**
 *  @brief      [ONLY SDK USE] Response of all
 *  @details    This function transfers data.
 *  @return     YES : Success  NO: Fail
 */
- (BOOL) sendPower:(NSData*)data;

/**
 *  @brief      [ONLY SDK USE] Response of all
 *  @details    This function attempts to connect the device.
 */
- (void) connectBLE:(CBPeripheral *)peripheral;
@end


